/****************************
CrushFTP GUI Plugin custom js
*****************************/
/* Do not change these lines */
var pluginHomeDirectory = {};
pluginHomeDirectory.localization = {};
/****************************/

// Plugin details
var pluginName = "HomeDirectory";
var _plugin = $("#pnlPlugin" + pluginName);

// Localizations
pluginHomeDirectory.localization = {
	lblEnabledText : "Enabled",
	lblDebugText : "Debug",
	lblVersionText : "Version : ",
	lblPathText : "Path : ",
	btnBrowseText : "Browse",
	lblDirectoryPermissionText : "Directory Permissions : ",
	lblUseUniqueTimeStampText : "Use Unique Time Stamped Folder? (ex. johndoe_01.01.2007)",
	lblUsernameMatchingText : "Username matching : ",
	lblPrependUserNameText : "Prepend username?",
	lblAlwaysGenerateHomeFolderText : "Always Generate Home Folder",
	lblRunOnlyForLoginEventText : "Only run if configured for a login event?",
	lblServerText : "Server : ",
	lblAllowAccessToOldHomeFoldersText : "Allow access to old home folders",
	lblCreateAdditionalSubfoldersText : " Create additional subfolders in home directory : "
};

// Assign localizations
localizations.panels["Plugins"][pluginName] = $.extend(pluginHomeDirectory.localization, localizations.panels["Plugins"][pluginName]);

// Interface methods
pluginHomeDirectory.init = function(pluginID, returnXML){
	pluginHomeDirectory.returnXML = returnXML;
	applyLocalizations(pluginName, localizations.panels["Plugins"]);
	$("#setupTabLink", _plugin).trigger("click");
	pluginHomeDirectory.bindData(0, pluginID);
}

pluginHomeDirectory.bindData = function(index, pluginID)
{
	index = index || 0;
	var pluginPrefs = [];
	pluginHomeDirectory.showServerList();
	if(pluginID)
	{
		var data = $(document).data("PluginBindData" + pluginID);
		pluginPrefs = data.dataItem;
		$(".nonEmbed", _plugin).hide();
	}
	else
	{
		pluginPrefs = common.data.getPluginPrefs(pluginName);
	}
	if(pluginPrefs)
	{
		var curPlugin = pluginPrefs;
		if(!pluginID && pluginPrefs.length)
		{
			curPlugin = pluginPrefs[index];
		}
		pluginHomeDirectory.bindPluginDetails(curPlugin);
	}
	pluginHomeDirectory.bindEvents();
}

pluginHomeDirectory.showServerList = function()
{
	var service = common;
	if(pluginHomeDirectory.returnXML)
	{
		service = userManager;
	}
	if(!this.serverListShown)
	{
		var serverList = service.data.getSubValueFromPrefs("server_list");
		var serverPorts = $("#server_item", _plugin);
		for(var i=0;i<serverList.length;i++)
		{
			var curItem = serverList[i];
			if(curItem)
			{
				var serverType = service.data.getTextContentFromPrefs(curItem, "serverType");
				var ip = service.data.getTextContentFromPrefs(curItem, "ip");
				var port = service.data.getTextContentFromPrefs(curItem, "port");
				var server = ip + "_" + port;
				var newControl = $("<option>"+server+"</option>");
				serverPorts.append(newControl);
				newControl.data("controlData", curItem);
			}
		}
		serverPorts.prepend("<option>All</option>");
		this.serverListShown = true;
	}
}

pluginHomeDirectory.bindEvents = function()
{
	if(this.eventAdded)return;
	_plugin.find("input, select, textarea").bind("change", function(){
		panelPlugins.itemsChanged(true, pluginHomeDirectory.returnXML, pluginName);
	});

	_plugin.find("input[type='text'], textarea").bind("textchange", function(){
		panelPlugins.itemsChanged(true, pluginHomeDirectory.returnXML, pluginName);
	});
	
	$("a.serverFilePickButton", _plugin).each(function(){
		$(this).click(function(){
			var curElem = $(this);
			curElem.crushFtpVFSBrowserPopup({
				type : curElem.attr("PickType") || 'dir',
				callback : function(selectedPath){
					$("#" + curElem.attr("rel"), _panel).val(selectedPath).trigger("change");
				}
			});
			return false;
		});
	});
	this.eventAdded = true;
}

pluginHomeDirectory.bindPluginDetails = function(controlData)
{
	var inputs = _plugin.find("input.ignoreBind,select.ignoreBind,textarea.ignoreBind").removeClass("ignoreBind");
	bindValuesFromXML(_plugin, controlData);
	if(controlData.subItem && controlData.subItem.length>0)
		_plugin.attr("subPluginName", controlData.subItem[0].text || false);
	inputs.addClass("ignoreBind");
}

pluginHomeDirectory.saveContent = function(saveByIndex, cloneName, removeByIndex, callback)
{
	removeByIndex = removeByIndex || 0;
	if(pluginPlaceHolder.data("hasChanged") || removeByIndex>0 || (saveByIndex>0 && cloneName) || pluginHomeDirectory.returnXML)
	{
		if(!pluginHomeDirectory.returnXML)
			common.UI.showIndicator(false, false, "Please wait..");

		var xmlString = [];
		var container = _plugin;
		if(removeByIndex == 0)
		{
			xmlString.push("<plugins_subitem type=\"properties\">");
			xmlString.push("<version>"+$("#version", _plugin).text()+"</version>");
			xmlString.push("<pluginName>"+pluginName+"</pluginName>");
			xmlString.push(buildXMLToSubmitForm(_plugin, true));
			if(saveByIndex)
			{
				xmlString.push("<subItem>"+common.methods.htmlEncode(cloneName)+"</subItem>");
			}
			else
			{
				if(container.attr("subPluginName") && this.subItem>0)
				{
					xmlString.push("<subItem>"+common.methods.htmlEncode(container.attr("subPluginName"))+"</subItem>");
				}
				else
				{
					xmlString.push("<subItem></subItem>");
				}
			}
			xmlString.push("</plugins_subitem>");
		}
		var formSubItem = xmlString.join("\n");

		if(pluginHomeDirectory.returnXML)
			return formSubItem;

		var action = removeByIndex == 0 ? "change" : "remove";
		var index = window.currentPluginIndex;
		var subItemIndex = removeByIndex == 0 ? saveByIndex || this.subItem : removeByIndex;
		subItemIndex = subItemIndex || 0;
		var removeChangeFlag = (saveByIndex>0 && cloneName);
		panelPlugins.savePluginContentProcess(action, formSubItem, index, subItemIndex, removeChangeFlag, callback);
	}
	else
	{
		growl("No changes made", "", false, 3000);
	}
}