/****************************
CrushFTP GUI Plugin custom js
*****************************/
/* Do not change these lines */
var pluginRadius = {};
pluginRadius.localization = {};
/****************************/

// Plugin details
var pluginName = "Radius";
var _plugin = $("#pnlPlugin" + pluginName);

// Localizations
pluginRadius.localization = {
	lblEnabledText : "Enabled",
	lblDebugText : "Debug",	
	lblVersionText : "Version :",
	lblAuthenticatorText : "Authenticator Type : ",
	lblUsernameTemplateText : "Username to use as template (except directory access) : ",
	lblPermissionsText : "Directory Permissions : ",
	lblServerItemText : "Server Item : ",
	lblServerItemNoteText :  "You can specify which server item will use this plugin. Example 	lookup_21, or lookup_8080",
	lblRadiusHostText : "Server Host : ",
	lblRadiusPortText : "Port : ",
	lblNASPortText : "NAS Port : ",
	lblRetriesText : "Retries : ",
	lblTimeoutText : "Timeout (s): ",
	lblSharedSecretText : "Shared Secret : ",
	lblHomeFolderLocationText : "Home folder location : ",
	btnBrowseText : "Browse",
	lblHomeFolderNoteText : "Username folder will be made in this location"
};

// Assign localizations
localizations.panels["Plugins"][pluginName] = $.extend(pluginRadius.localization, localizations.panels["Plugins"][pluginName]);

// Interface methods
pluginRadius.init = function(pluginID, returnXML){
	pluginRadius.returnXML = returnXML;
	applyLocalizations(pluginName, localizations.panels["Plugins"]);
	pluginRadius.bindData(0, pluginID);
}

pluginRadius.bindData = function(index, pluginID)
{
	index = index || 0;
	var pluginPrefs = [];
	pluginRadius.showServerList();
	if(pluginID)
	{
		var data = $(document).data("PluginBindData" + pluginID);
		pluginPrefs = data.dataItem;
		$(".nonEmbed", _plugin).hide();
	}
	else
	{
		pluginPrefs = common.data.getPluginPrefs(pluginName);
	}
	if(pluginPrefs)
	{
		var curPlugin = pluginPrefs;
		if(!pluginID && pluginPrefs.length)
		{
			curPlugin = pluginPrefs[index];
		}
		pluginRadius.bindPluginDetails(curPlugin);
	}
	pluginRadius.loadedSubItem = index;
	pluginRadius.bindEvents(index);
}

pluginRadius.bindEvents = function()
{
	if(this.eventAdded)return;
	_plugin.find("input, select, textarea").bind("change", function(){
		panelPlugins.itemsChanged(true, pluginRadius.returnXML, pluginName);
	});

	_plugin.find("input[type='text'], textarea").bind("textchange", function(){
		panelPlugins.itemsChanged(true, pluginRadius.returnXML, pluginName);
	});
	
	$("a.serverFilePickButton", _plugin).each(function(){
		$(this).click(function(){
			var curElem = $(this);
			curElem.crushFtpVFSBrowserPopup({
				type : curElem.attr("PickType") || 'dir',
				callback : function(selectedPath){
					$("#" + curElem.attr("rel"), _plugin).val(selectedPath).trigger("change");
				}
			});
			return false;
		});
	});

	this.eventAdded = true;
}

pluginRadius.bindPluginDetails = function(controlData)
{
	var inputs = _plugin.find("input.ignoreBind,select.ignoreBind,textarea.ignoreBind").removeClass("ignoreBind");
	bindValuesFromXML(_plugin, controlData);
	if(controlData.subItem && controlData.subItem.length>0)
		_plugin.attr("subPluginName", controlData.subItem[0].text || false);
	inputs.addClass("ignoreBind");
}

pluginRadius.showServerList = function()
{
	if(!this.serverListShown)
	{
		var service = common;
		if(pluginRadius.returnXML)
		{
			service = userManager;
		}
		var serverList = service.data.getSubValueFromPrefs("server_list");
		var serverPorts = $("#server_item", _plugin).empty();
		for(var i=0;i<serverList.length;i++)
		{
			var curItem = serverList[i];
			if(curItem)
			{
				var serverType = service.data.getTextContentFromPrefs(curItem, "serverType");
				var ip = service.data.getTextContentFromPrefs(curItem, "ip");
				var port = service.data.getTextContentFromPrefs(curItem, "port");
				var server = ip + "_" + port;
				var newControl = $("<option>"+server+"</option>");
				serverPorts.append(newControl);
				newControl.data("controlData", curItem);
			}
		}
		serverPorts.prepend("<option>All</option>");
		this.serverListShown = true;
	}
}

pluginRadius.saveContent = function(saveByIndex, cloneName, removeByIndex, callback, noGrowl)
{
	removeByIndex = removeByIndex || 0;
	if(pluginPlaceHolder.data("hasChanged") || removeByIndex>0 || (saveByIndex>0 && cloneName) || pluginRadius.returnXML)
	{
		if(!pluginRadius.returnXML)
			common.UI.showIndicator(false, false, "Please wait..");
		var xmlString = [];
		var container = _plugin;
		if(removeByIndex == 0)
		{
			xmlString.push("<plugins_subitem type=\"properties\">");
			xmlString.push("<version>"+$("#version", _plugin).text()+"</version>");
			xmlString.push("<pluginName>"+pluginName+"</pluginName>");
			xmlString.push(buildXMLToSubmitForm(_plugin, true));
			if(saveByIndex)
			{
				xmlString.push("<subItem>"+common.methods.htmlEncode(cloneName)+"</subItem>");
			}
			else
			{
				if(container.attr("subPluginName") && this.subItem>0)
				{
					xmlString.push("<subItem>"+common.methods.htmlEncode(container.attr("subPluginName"))+"</subItem>");
				}
				else
				{
					xmlString.push("<subItem></subItem>");
				}
			}
			xmlString.push("</plugins_subitem>");
		}
		var formSubItem = xmlString.join("\n");

		if(pluginRadius.returnXML)
			return formSubItem;

		var action = removeByIndex == 0 ? "change" : "remove";
		var index = window.currentPluginIndex;
		var subItemIndex = removeByIndex == 0 ? saveByIndex || this.subItem : removeByIndex;
		subItemIndex = subItemIndex || 0;
		var removeChangeFlag = (saveByIndex>0 && cloneName);
		panelPlugins.savePluginContentProcess(action, formSubItem, index, subItemIndex, removeChangeFlag, callback, noGrowl);
	}
	else
	{
		if(!noGrowl)
			growl("No changes made", "", false, 3000);
		else
			callback(true);
	}
}