/****************************
CrushFTP GUI Panel custom js
*****************************/
/* Do not change these lines */
var panelAdmin = {};
panelAdmin.localization = {};
/****************************/

// Panel details
var panelName = "Admin";
panelAdmin._panel = $("#pnl" + panelName);

// Localizations
panelAdmin.localization = {
};

// Assign localizations
localizations.panels[panelName] = $.extend(panelAdmin.localization, localizations.panels[panelName]);

// Interface methods
panelAdmin.init = function(){
	applyLocalizations(panelName, localizations.panels);
	window.dataBindEvents.push(panelAdmin.bindData);
	panelAdmin.bindEvents();
}

panelAdmin.clearItems = function(dataPanel)
{
	dataPanel.find("input.siteField:checked").each(function(){
		userManager.UI.checkUnchekInput($(this), false);
	});
}

panelAdmin.bindData = function(userInfo, jsonDeep, panel)
{
	var dataPanel = panel || panelAdmin._panel;
	if(panel)
	{
		panel.removeClass("inheritValSet");
	}
	panelAdmin.clearItems(dataPanel);
	if(userInfo.user)
	{
		userManager.data.bindValuesFromJson(dataPanel, userInfo.user, false, panel);

		var dataInheritedFrom = false;
		var curData = userManager.methods.seperateValueAndInheritValue(userManager.data.getValueFromJson(userInfo.user, "site"));
		var value = curData.value;
		dataInheritedFrom = curData.inherit || dataInheritedFrom;
		var sitePrefs = value.toLowerCase();		
		$("input.siteField", dataPanel).each(function(){
			if(sitePrefs.indexOf($(this).attr("id"))>=0)
			{
				userManager.UI.checkUnchekInput($(this), true);
			}
		});
		if(!panel)
		{
			userManager.data.setInheritPropertyOfSection($("div.siteSettings", dataPanel), "site", true);
		}
		userManager.methods.showInheritValueLabel($("div.siteSettings", dataPanel), dataInheritedFrom);
	}
	userManager.UI.panelsPostbindEvent(dataPanel, panel);
}

panelAdmin.bindEvents = function()
{
	userManager.UI.togglePanels(panelAdmin._panel);
	$(".checkboxArea>input[type='checkbox']", panelAdmin._panel).change(function(){
		var curUserData = userManager.storage("currentUserInherited");
		if(!$(this).is(":checked"))
		{
			curUserData = {user: userManager.storage("currentUsersLowerLevelsData")};
			$(this).closest("fieldset").addClass("inheritSet");
		}
		else
			$(this).closest("fieldset").removeClass("inheritSet");
		if(!$(this).closest("fieldset").hasClass("notInheritable"))
			panelAdmin.bindData(curUserData, false, $(this).closest("fieldset"));
	});

	$("#web_admin, #user_admin", panelAdmin._panel).change(function(){
		if(!$(this).is(":checked"))
		{
			var changedItem = $(this);
			var editingUserData = userManager.storage("currentUser");
			if(editingUserData && editingUserData.user && editingUserData.user.username)
			{
				var loggedInUser = userManager.storage("username");
				var editingUser = editingUserData.user.username;
				if(loggedInUser.toLowerCase() == editingUser.toLowerCase())
				{
					jConfirm("You are making changes to current logged in user, this setting may restrict you from using web interface, Are you sure you want to do that?", "Confirm", function(value){
						userManager.UI.checkUnchekInput(changedItem, !value);
					});
				}
			}
		}
	});
}

panelAdmin.getDataXML = function(data)
{
	data = data || {};
	data.site = "";
	panelAdmin._panel.find("input.siteField:checked").each(function(){
		if(typeof $(this).attr("id") != "undefined")
			data.site += "("+$(this).attr("id").toUpperCase()+")";
	});
	return data;
}

panelAdmin.generateXML = function()
{
	var xml = "";

	//General items
	panelAdmin._panel.find("td.checkboxArea").not(".specialProperty").find("input:checked").each(function(){
		var formPanel = $(this).closest("td").next();
		xml += "\r\n" + userManager.data.buildXMLToSubmitForm(formPanel);
	});

	if(panelAdmin._panel.find("#sitePrefsCheck").find("input:checked").length>0)
	{
		xml += "\r\n<site>";
		$("input.siteField:checked", panelAdmin._panel).each(function(){
			if(typeof $(this).attr("id") != "undefined")
				xml += "(" + $(this).attr("id").toUpperCase() + ")";
		});
		xml += "\r\n</site>";
	}
	return xml;
}